/**
 * ValidatorInput.java
 *
 * File generated from the XValidator::ValidatorInput uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

// End of user code
import org.w3c.dom.Node;

import javax.persistence.*;
import javax.xml.bind.annotation.*;

/**
 * Description of the class ValidatorInput.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ValidatorInput", propOrder = { "maxQuantity", "minQuantity", "referencedObject"})
@XmlRootElement(name = "ValidatorInput")
@Entity
@Table(name = "xval_validator_input", schema = "public")
@SequenceGenerator(name = "xval_validator_input_sequence", sequenceName = "xval_validator_input_id_seq", allocationSize = 1)
public class ValidatorInput implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@XmlTransient
	@GeneratedValue(generator = "xval_validator_input_sequence", strategy = GenerationType.SEQUENCE)
	@Column(name = "id", unique = true, nullable = false)
	private Integer id;
	/**
	 * 1 is the default value, 0 means unlimited.
	 */
	@XmlAttribute(name = "maxQuantity")
	@Column(name = "max_quantity")
	private Integer maxQuantity;
	/**
	 * How many of this file are required at least .
	 */
	@XmlAttribute(name = "minQuantity")
	@Column(name = "min_quantity")
	private Integer minQuantity;

	@XmlElement(name = "ReferencedObject")
	@ManyToOne(cascade={CascadeType.MERGE, CascadeType.PERSIST})
	@JoinColumn(name = "referenced_object_id")
	private ReferencedObject referencedObject;

	@XmlAttribute(name = "message_type", required = true)
	@Column(name = "message_type")
	@Enumerated(EnumType.STRING)
	private MessageType messageType;

	@XmlTransient
	@ManyToOne
	@JoinColumn(name = "gazelle_cross_validator_id")
	private GazelleCrossValidatorType gazelleCrossValidator;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	public ValidatorInput() {
		super();
		this.maxQuantity = 1;
		this.minQuantity = 1;
	}

	public ValidatorInput(GazelleCrossValidatorType gazelleCrossValidatorType) {
		this.gazelleCrossValidator = gazelleCrossValidatorType;
		this.maxQuantity = 1;
		this.minQuantity = 1;
	}

	public ValidatorInput(ValidatorInput parentInput) {
		super();
		this.maxQuantity = parentInput.getMaxQuantity();
		this.minQuantity = parentInput.getMinQuantity();
		this.referencedObject = parentInput.getReferencedObject();
		this.messageType = parentInput.getMessageType();
	}

	/**
	 * Return maxQuantity.
	 * 
	 * @return maxQuantity : 1 is the default value, 0 means unlimited1 is the default value, 0 means unlimited
	 */
	public Integer getMaxQuantity() {
		return maxQuantity;
	}

	/**
	 * Set a value to attribute maxQuantity.
	 * 
	 * @param maxQuantity
	 *            : 1 is the default value, 0 means unlimited1 is the default value, 0 means unlimited.
	 */
	public void setMaxQuantity(Integer maxQuantity) {
		this.maxQuantity = maxQuantity;
	}

	/**
	 * Return minQuantity.
	 * 
	 * @return minQuantity : How many of this file are required at least How many of this file are required at least
	 */
	public Integer getMinQuantity() {
		return minQuantity;
	}

	/**
	 * Set a value to attribute minQuantity.
	 * 
	 * @param minQuantity
	 *            : How many of this file are required at least How many of this file are required at least .
	 */
	public void setMinQuantity(Integer minQuantity) {
		this.minQuantity = minQuantity;
	}


	/**
	 * Return messageType.
	 *
	 * @return messageType
	 */
	public MessageType getMessageType() {
		return messageType;
	}

	/**
	 * Set a value to attribute messageType.
	 *
	 * @param msgType
	 *            .
	 */
	public void setMessageType(MessageType msgType) {
		this.messageType = msgType;
	}

	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "ValidatorInput", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	public ReferencedObject getReferencedObject() {
		return referencedObject;
	}

	public void setReferencedObject(ReferencedObject referencedObject) {
		this.referencedObject = referencedObject;
	}

	public GazelleCrossValidatorType getGazelleCrossValidator() {
		return this.gazelleCrossValidator;
	}

	public void setGazelleCrossValidator(GazelleCrossValidatorType gazelleCrossValidator) {
		this.gazelleCrossValidator = gazelleCrossValidator;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}

		ValidatorInput that = (ValidatorInput) o;

		if (maxQuantity != null ? !maxQuantity.equals(that.maxQuantity) : that.maxQuantity != null) {
			return false;
		}
		if (minQuantity != null ? !minQuantity.equals(that.minQuantity) : that.minQuantity != null) {
			return false;
		}
		if (referencedObject != null ? !referencedObject.equals(that.referencedObject) : that.referencedObject != null) {
			return false;
		}
		if (messageType != that.messageType) {
			return false;
		}
		return gazelleCrossValidator != null ? gazelleCrossValidator.equals(that.gazelleCrossValidator) : that.gazelleCrossValidator == null;
	}

	@Override
	public int hashCode() {
		int result = maxQuantity != null ? maxQuantity.hashCode() : 0;
		result = 31 * result + (minQuantity != null ? minQuantity.hashCode() : 0);
		result = 31 * result + (referencedObject != null ? referencedObject.hashCode() : 0);
		result = 31 * result + (messageType != null ? messageType.hashCode() : 0);
		result = 31 * result + (gazelleCrossValidator != null ? gazelleCrossValidator.hashCode() : 0);
		return result;
	}

	public boolean requiresXSDValidation() {
		return (referencedObject.requiresXSDValidation());
	}

	public String getXsdLocation() {
		return referencedObject.getXsdLocation();
	}

	public String getKeyword() {
		return referencedObject.getKeyword();
	}
	
	public boolean isXml(){
		if (referencedObject != null){
			return referencedObject.isXml();
		} else {
			return false;
		}
	}
}